Subject: [Megaco] ETSI H.248 Ia Profile: issue with media value '-' in SDP "m=" line

From: [email-masked]
Date: Thu, 13 Jul 2006 18:19:42 +0200

Christer, et al.,

media value '-' is not allowed by RFC 2327 (& RFC 3108) in our
understanding:

   RFC 2327:

   media-descriptions =  *( media-field

                            information-field

                            *(connection-field)

                            bandwidth-fields

                            key-field

                            attribute-fields )

      media-field =         "m=" media space port ["/" integer]

                            space proto 1*(space fmt) CRLF

      media =               1*(alpha-numeric)

                            ;typically "audio", "video", "application"

                            ;or "data"

   RFC 3108:

   media-descriptions = *(media-description)

   media-description  = media-field information-field *(connection-field)

                        bandwidth-fields key-field attribute-fields

   media-field = RFC 2327-media-field / RFC 2848-media-field /

                 atm-media-field

       ; RFC 2327-media-field and RFC 2848-media-field defined in those
   rfc's

   atm-media-field = "m=" media space vcId space transport-fmts EOL

      ; superset of RFC 2327 definition

   media = "audio" / "video" / "data" / "application" / "control" /

           1*(alpha-numeric)

If our understanding is correct then either

(1) ETSI ES 283 018 is extending the SDP codepoint space, leading to
further differences between H.248/SDP and SIP/SDP, with further mapping
requirements for the "SDP mapper" (ETSI TR 183 046; WI-03062), or

(2) alternatively we could change the codepoint '-' to an allowed codepoint
(e.g., '0', 'none' or 'mediaagnostic' or sth similar).

We are in favour of (2) due to compliance to RFC 2327.
What is the feeling of others (Tom, guess you got some deep insights with
your work on media formats and SDP usage in msf2006.046.01)?

Regards,
Albrecht

PS
Didn't checked yet whether '-' is affecting other SDP codepoints, too.

Reference:
ETSI ES 283 018 V1.1.1 (2006-06)

5.15     Mandatory support of SDP and annex C information elements

               Table 81: Supported SDP Information Elements
|---------------------------+---------------------------+-----------------------------|
|  SDP Information Element  |     Mandatory/optional    |         Description         |
|---------------------------+---------------------------+-----------------------------|
| Protocol version          | Mandatory                 | The value must always be    |
| "v=" line                 |                           | equals to zero:             |
|                           |                           | v=0                         |
|---------------------------+---------------------------+-----------------------------|
| Connection                | Mandatory                 | The network type must always|
| "c=" line                 |                           | be "IN".                    |
|                           |                           |                             |
|                           |                           |The address type value must  |
|                           |                           |be "IP4" or "IP6".           |
|                           |                           |                             |
|                           |                           |The connection address value |
|                           |                           |may be underspecified with   |
|                           |                           |CHOOSE wildcard ("$").       |
|---------------------------+---------------------------+-----------------------------|
| Media                     | Mandatory                 |"-" may be used for the media|
| "m=" line                 |                           |value. Other values shall be |
|                           |                           |ignored, unless media        |
|                           |                           |specific information is      |
|                           |                           |required.                    |
|                           |                           |                             |
|                           |                           |The port value may be        |
|                           |                           |underspecified with CHOOSE   |
|                           |                           |wildcard ("$").              |
|                           |                           |                             |
|                           |                           |"-" may be used for the      |
|                           |                           |transport value, unless      |
|                           |                           |transport specific behaviour |
|                           |                           |is required by the MG.       |
|                           |                           |(See note)                   |
|                           |                           | "-" may be used for the     |
|                           |                           | format list value. Other    |
|                           |                           | values shall be ignored.    |
|---------------------------+---------------------------+-----------------------------|

_______________________________________________
Megaco mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/megaco

---

From: "B Venkat S.R Swamy" <[email-masked]>
Date: Fri, 14 Jul 2006 09:29:50 +0530

Hi

I support the option 2, and we should try to avoid any violation of the RFC 2327/RFC 3108.

The string "OMIT" as suggested by RFC 3108, section 2.5, can be used for media.

Also the use of "-" is not allowed as per RFC 2327/RFC 2848 for the proto field.

regards

B Venkat S.R Swamy

Senior Technical Leader

Flextronics Software Systems

Phone: +91-124- 4176213

Fax: +91-124-4300247

web: www.flextronicssoftware.com

[email-masked]

[email-masked]

07/13/2006 09:49 PM

To

[email-masked], [email-masked]

cc

[email-masked]

Subject

[Megaco] ETSI H.248 Ia Profile: issue with media value '-' in SDP"m=" line

Christer, et al.,

understanding:

RFC 2327:

information-field

*(connection-field)

bandwidth-fields

key-field

attribute-fields )

;or "data"

RFC 3108:

atm-media-field

rfc's

1*(alpha-numeric)

Regards,

Albrecht

PS

Reference:

|                           |                           | v=0                         |

|                           |                           |                             |

|                           |                           |                             |

|                           |                           |required.                    |

|                           |                           |                             |

|                           |                           |wildcard ("$").              |

|                           |                           |                             |

|                           |                           |(See note)                   |

Megaco mailing list

[email-masked]

*********************** FSS-Restricted ***********************

"DISCLAIMER: This message is proprietary to Flextronics Software

Systems Limited (FSS) and is intended solely for the use of the

individual to whom it is addressed. It may contain privileged or

confidential information and should not be circulated or used for

any purpose other than for what it is intended. If you have received

this message in error, please notify the originator immediately.

If you are not the intended recipient, you are notified that you are

strictly prohibited from using, copying, altering, or disclosing

the contents of this message. FSS accepts no responsibility for

loss or damage arising from the use of the information transmitted

by this email including damage from virus."

---

From: [email-masked]
Date: Fri, 14 Jul 2006 08:53:02 +0200

Thanks for pointing to § 2.5/RFC 3108!
" The string "OMIT" can be used in lieu of "-" for an omitted parameter."
Seems to be the best change proposal IMHO.
- Albrecht

RFC 3108:
   2.5 Use of special characters in SDP parameter values

      In general, RFC 2327-conformant string values of SDP parameters [1]
      do not include special characters that are neither alphabets nor
      digits.  An exception is the "/" character used in the value
      "RTP/AVP" of transport sub-field of the 'm' line.

      String values used in SDP descriptions of ATM connections retain this
      convention, while allowing the use of the special character "/" in a
      manner commensurate with [1].  In addition, the special characters
      "$" and "-" are used in the following manner.  A "$" value is a
      wildcard that allows the recipient of the SDP description to select
      any permitted value of the parameter.  A "-" value indicates that it
      is not necessary to specify the value of the parameter in the SDP
      description because this parameter is irrelevant for this
      application, or because its value can be known from another source
      such as provisioning, defaults, another protocol, another SDP
      descriptor or another part of the same SDP descriptor.  If the use of
      these special characters is construed as a violation of RFC 2327 [1]
      syntax, then reserved string values can be used.  The string "CHOOSE"
      can be used in lieu of "$".  The string "OMIT" can be used in lieu of
      "-" for an omitted parameter.

                      "B Venkat S.R Swamy"                                                                                              
                      <b.swamy@flextronicsso         To:      Albrecht SCHWARZ/DE/ALCATEL@ALCATEL                                       
                      ftware.com>                    cc:      [email-masked], [email-masked]                           
                                                     Subject: Re: [Megaco] ETSI H.248 Ia Profile: issue with media value '-' in SDP"m=" 
                      14.07.2006 05:59               line                                                                               

Hi

I support the option 2, and we should try to avoid any violation of the RFC
2327/RFC 3108.
The string "OMIT" as suggested by RFC 3108, section 2.5, can be used for
media.
Also the use of "-" is not allowed as per RFC 2327/RFC 2848 for the proto
field.

regards
B Venkat S.R Swamy
Senior Technical Leader
Flextronics Software Systems
Phone: +91-124- 4176213
Fax: +91-124-4300247
web: www.flextronicssoftware.com
(Embedded image moved to file: pic12377.gif)[email-masked]

                         Albrecht                                          
                         .Schwarz                                          
                         @alcatel                                          
                         .de      (Embedded image moved to file:           
                                  pic00224.gif)                            
                                                                        To 
                         07/13/20          (Embedded image moved to file:  
                         06 09:49          pic02722.gif)                   
                         PM                [email-masked], 
                                           [email-masked]               
                                  (Embedded image moved to file:           
                                  pic31609.gif)                            
                                                                        cc 
                                           (Embedded image moved to file:  
                                           pic17314.gif)                   
                                           [email-masked]                 
                                  (Embedded image moved to file:           
                                  pic14997.gif)                            
                                                                   Subject 
                                           (Embedded image moved to file:  
                                           pic24297.gif)                   
                                           [Megaco] ETSI H.248 Ia Profile: 
                                           issue with media value '-' in   
                                           SDP"m=" line                    

                                  (Embedded image moved to file:           
                                  pic24565.gif)                            
                                         (Embedded image moved to file:    
                                         pic28141.gif)                     

Christer, et al.,

  RFC 2327:

                           information-field

                           *(connection-field)

                           bandwidth-fields

                           key-field

                           attribute-fields )

                           ;or "data"

  RFC 3108:

                atm-media-field

          1*(alpha-numeric)

Regards,
Albrecht

PS

Reference:

|  SDP Information Element  |     Mandatory/optional    |
Description         |
|---------------------------+---------------------------+-----------------------------|

| Protocol version          | Mandatory                 | The value must
always be    |
| "v=" line                 |                           | equals to zero:
|
|                           |                           | v=0
|
|---------------------------+---------------------------+-----------------------------|

| Connection                | Mandatory                 | The network type
must always|
| "c=" line                 |                           | be "IN".
|
|                           |                           |
|
|                           |                           |The address type
value must  |
|                           |                           |be "IP4" or "IP6".
|
|                           |                           |
|
|                           |                           |The connection
address value |
|                           |                           |may be
underspecified with   |
|                           |                           |CHOOSE wildcard
("$").       |
|---------------------------+---------------------------+-----------------------------|

| Media                     | Mandatory                 |"-" may be used
for the media|
| "m=" line                 |                           |value. Other
values shall be |
|                           |                           |ignored, unless
media        |
|                           |                           |specific
information is      |
|                           |                           |required.
|
|                           |                           |
|
|                           |                           |The port value may
be        |
|                           |                           |underspecified
with CHOOSE   |
|                           |                           |wildcard ("$").
|
|                           |                           |
|
|                           |                           |"-" may be used
for the      |
|                           |                           |transport value,
unless      |
|                           |                           |transport specific
behaviour |
|                           |                           |is required by the
MG.       |
|                           |                           |(See note)
|
|                           |                           | "-" may be used
for the     |
|                           |                           | format list
value. Other    |
|                           |                           | values shall be
ignored.    |
|---------------------------+---------------------------+-----------------------------|

---

From: Christian Groves <[email-masked]>
Date: Mon, 17 Jul 2006 11:06:49 +1000

Hello Albrecht,

In Q.1950 which encounters a similar issue it states :

"NOTE - "-" indicates "do not care" – i.e. the field should be set to 
any value valid according to SDP, but it is not
used on the CBC interface."

So a profile may specify what values it doesn't care about. If it 
receives normal SDP values in those positions these can simply be 
ignored. No need to say OMIT.

Regards, Christian

[email-masked] wrote:

> ------------------------------------------------------------------------
>
>
> ------------------------------------------------------------------------
>
>
> ------------------------------------------------------------------------
>
>
> ------------------------------------------------------------------------
>
>
> ------------------------------------------------------------------------
>
>
> ------------------------------------------------------------------------
>
>
> ------------------------------------------------------------------------
>
>
> ------------------------------------------------------------------------
>
>
> ------------------------------------------------------------------------
>
>------------------------------------------------------------------------
>

---

From: Christian Groves <[email-masked]>
Date: Mon, 17 Jul 2006 14:45:44 +1000

Hello,

I think you missed the point of my email. I was not suggesting to use 
"-". If the MGC truly doesn't care about a value then it can send 
whatever legal SDP it wants. In the case of H.248 it can send ? because 
it doesn't care what the response will be.

Regards, Christian

B Venkat S.R Swamy wrote:

> Hi
>
> Although you are right these are don't care values, but the point here 
> was SDP grammar does not support
> "-" in the media as shown below.
>
> "m=" media space port ["/" integer] space proto 1*(space fmt) CRLF
>
> therefore the string "OMIT" was suggested for the media, so as not to 
> violate the SDP grammar.
>
>
> regards
> B Venkat S.R Swamy
> Senior Technical Leader
> Inactive hide details for Christian Groves 
> <[email-masked]>Christian Groves 
> <[email-masked]>
>
>
>                         *Christian Groves
>                         <[email-masked]>*
>
>                         07/17/2006 06:36 AM
>
> 	
>
> To
> 	
> B Venkat S.R Swamy/HSS@HSS, [email-masked], 
> [email-masked]
>
> Subject
> 	
> Re: [Megaco] ETSI H.248 Ia Profile: issue with media value '-' 
> inSDP"m=" line
>
> 	
>
>
> Hello Albrecht,
>

---

From: "B Venkat S.R Swamy" <[email-masked]>
Date: Mon, 17 Jul 2006 10:10:05 +0530

Hi

Although you are right these are don't care values, but the point here was SDP grammar does not support

;or "data"

therefore the string "OMIT" was suggested for the media, so as not to violate the SDP grammar.

regards

B Venkat S.R Swamy

Senior Technical Leader

Phone: +91-124- 4176213

Fax: +91-124-4300247

Christian Groves <[email-masked]>

Christian Groves <[email-masked]>

07/17/2006 06:36 AM

To

cc

B Venkat S.R Swamy/HSS@HSS, [email-masked], [email-masked]

Subject

Re: [Megaco] ETSI H.248 Ia Profile: issue with media value '-' inSDP"m=" line

Hello Albrecht,

Regards, Christian

---

From: "Kevin Boyle" <[email-masked]>
Date: Mon, 17 Jul 2006 12:58:20 -0400

The MGC could place "$" there if it truly did not care.  This would
align better with the intent of both SDP and H.248.
 
Kevin

________________________________

From: B Venkat S.R Swamy [mailto:[email-masked]] 
Sent: Monday, July 17, 2006 12:40 AM
To: Christian Groves
Cc: [email-masked]; [email-masked];
[email-masked]
Subject: Re: [Megaco] ETSI H.248 Ia Profile: issue with media value '-'
inSDP"m=" line

Hi

regards
B Venkat S.R Swamy 
Senior Technical Leader

				Christian Groves

				07/17/2006 06:36 AM

To

cc

Subject

Re: [Megaco] ETSI H.248 Ia Profile: issue with media value '-' inSDP"m="
line	

Hello Albrecht,

"NOTE - "-" indicates "do not care" - i.e. the field should be set to 
any value valid according to SDP, but it is not
used on the CBC interface."

Regards, Christian

>                      ftware.com>                    cc:
[email-masked], [email-masked]

>                                                     Subject: Re:
[Megaco] ETSI H.248 Ia Profile: issue with media value '-' in SDP"m=" 

To 

cc 

Subject 

>|                           |                           |The address
type
>|                           |                           |be "IP4" or
"IP6".
>|                           |                           |CHOOSE
wildcard
>|                           |                           |ignored,
unless
>|                           |                           |The port value
may
>|                           |                           |wildcard
("$").
>|                           |                           |"-" may be
used
>|                           |                           |transport
value,
>|                           |                           |transport
specific
>|                           |                           |is required by
the
>|                           |                           | "-" may be
used
>|                           |                           | values shall
be

---

From: "Tom-PT Taylor" <[email-masked]>
Date: Thu, 20 Jul 2006 10:20:17 -0400

RFC 4566 is the latest version of SDP. It has changed:

      media-field =         "m=" media SP port ["/" integer]
                             SP proto 1*(SP fmt) CRLF

      ; sub-rules of 'm='
      media =               token
                            ;typically "audio", "video", "text" or
                            ;"application"

      token =               1*(token-char)

      token-char =          %x21 / %x23-27 / %x2A-2B / %x2D-2E / %x30-39
                            / %x41-5A / %x5E-7E